commit bf0c732dd532c6474f7508e98a6989bbfb9299e7
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Wed Jun 9 11:11:00 2021

    libstdc++: Add warnings for some C++23 deprecations
    
    LWG 3036 deprecates std::pmr::polymorphic_allocator<T>::destroy in
    favour of the equivalent member of std::allocator_traits.
    
    LWG 3170 deprecates std::allocator<T>::is_always_equal in favour of
    the equivalent member of std::allocator_traits.
    
    This also updates a comment to note that we support the LWG 3541 change
    (even before the issue was opened).
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            * include/bits/allocator.h (allocator::is_always_equal): Deprecate.
            * include/bits/iterator_concepts.h (indirectly_readable_traits):
            Add LWG issue number to comment.
            * include/std/memory_resource (polymorphic_allocator::release):
            Deprecate.
            * testsuite/20_util/allocator/requirements/typedefs.cc: Add
            dg-warning for deprecation. Also check std::allocator<void>.
    
    (cherry picked from commit 5bfcfe3087eb05b76395c9efbfc1abbf3f9e1a03)

diff --git a/libstdc++-v3/include/bits/allocator.h b/libstdc++-v3/include/bits/allocator.h
index 73d5d7a25be..396872ffae5 100644
--- a/libstdc++-v3/include/bits/allocator.h
+++ b/libstdc++-v3/include/bits/allocator.h
@@ -89,9 +89,11 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 #if __cplusplus >= 201103L
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
       // 2103. std::allocator propagate_on_container_move_assignment
-      typedef true_type propagate_on_container_move_assignment;
+      using propagate_on_container_move_assignment = true_type;
 
-      typedef true_type is_always_equal;
+      using is_always_equal
+	_GLIBCXX20_DEPRECATED_SUGGEST("allocator_traits::is_always_equal")
+	= true_type;
 
 #if __cplusplus >= 202002L
       allocator() = default;
@@ -157,9 +159,11 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 #if __cplusplus >= 201103L
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
       // 2103. std::allocator propagate_on_container_move_assignment
-      typedef true_type propagate_on_container_move_assignment;
+      using propagate_on_container_move_assignment = true_type;
 
-      typedef true_type is_always_equal;
+      using is_always_equal
+	_GLIBCXX20_DEPRECATED_SUGGEST("allocator_traits::is_always_equal")
+	= true_type;
 #endif
 
       // _GLIBCXX_RESOLVE_LIB_DEFECTS
diff --git a/libstdc++-v3/include/bits/iterator_concepts.h b/libstdc++-v3/include/bits/iterator_concepts.h
index ccc0a19dafd..11748e5ed7b 100644
--- a/libstdc++-v3/include/bits/iterator_concepts.h
+++ b/libstdc++-v3/include/bits/iterator_concepts.h
@@ -264,8 +264,8 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
     : __detail::__cond_value_type<typename _Tp::value_type>
     { };
 
-  // LWG 3446 doesn't add this, but it's needed for the case where
-  // value_type and element_type are both present, but not the same type.
+  // _GLIBCXX_RESOLVE_LIB_DEFECTS
+  // 3541. indirectly_readable_traits should be SFINAE-friendly for all types
   template<__detail::__has_member_value_type _Tp>
     requires __detail::__has_member_element_type<_Tp>
     struct indirectly_readable_traits<_Tp>
diff --git a/libstdc++-v3/include/std/memory_resource b/libstdc++-v3/include/std/memory_resource
index d330da9de5b..df4e806f814 100644
--- a/libstdc++-v3/include/std/memory_resource
+++ b/libstdc++-v3/include/std/memory_resource
@@ -322,6 +322,7 @@ namespace pmr
 #endif
 
       template<typename _Up>
+	_GLIBCXX20_DEPRECATED_SUGGEST("allocator_traits::destroy")
 	__attribute__((__nonnull__))
 	void
 	destroy(_Up* __p)
diff --git a/libstdc++-v3/testsuite/20_util/allocator/requirements/typedefs.cc b/libstdc++-v3/testsuite/20_util/allocator/requirements/typedefs.cc
index ca4714d108f..4f1f46a3465 100644
--- a/libstdc++-v3/testsuite/20_util/allocator/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/20_util/allocator/requirements/typedefs.cc
@@ -53,5 +53,27 @@ static_assert( is_same<allocator<int>::propagate_on_container_move_assignment,
                        std::true_type>::value,
                "propagate_on_container_move_assignment" );
 
-static_assert( is_same<allocator<int>::is_always_equal, std::true_type>::value,
-               "is_always_equal" );
+using IAE = allocator<int>::is_always_equal; // { dg-warning "deprecated" "" { target c++20 } }
+static_assert( is_same<IAE, std::true_type>::value, "is_always_equal" );
+
+
+// Test required typedefs for allocator<void> specialization.
+static_assert( is_same<allocator<void>::value_type, void>::value,
+	       "void value_type" );
+#if __cplusplus <= 201703L
+static_assert( is_same<allocator<void>::pointer, void*>::value,
+	       "void pointer" );
+static_assert( is_same<allocator<void>::const_pointer, const void*>::value,
+	       "void const_pointer" );
+static_assert( is_same<allocator<void>::rebind<char>::other,
+                       allocator<char>>::value,
+               "void rebind::other" );
+#else
+// Since C++20 allocator<void> uses the primary template, so has the same types.
+static_assert( is_same<allocator<void>::propagate_on_container_move_assignment,
+                       std::true_type>::value,
+               "propagate_on_container_move_assignment" );
+
+using VIAE = allocator<void>::is_always_equal; // { dg-warning "deprecated" "" { target c++20 } }
+static_assert( is_same<VIAE, std::true_type>::value, "is_always_equal" );
+#endif

